<?php
/*
 Plugin Name: Link Magic
 Plugin URI: https://epicmarketer.com/software
 Description: Cloak, brand and track your links easily with Link Magic!
 Version: 3.2
 Author: Mike Cowles
 Author URI: https://epicmarketer.com
 */


add_action( 'wp', 'block_post_linkmagic' );//This is the hook part
function block_post_linkmagic(){
    global $wpdb;
    global $post;
    // global $license;
    
    $SiteURL=site_url();
    $SiteURL=str_replace('http://','',$SiteURL);
    $SiteURL=str_replace('https://','',$SiteURL);
    $SiteURL=str_replace('wwww','',$SiteURL);
    $RootURL=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
    $Final=str_replace($SiteURL,'',$RootURL);
    $Final=str_replace('/','',$Final);
    if( strpos($Final, "?") !== false ){
        $Final = substr( $Final, 0, strpos($Final, "?"));
    }
    $re=" SELECT * FROM ".$wpdb->prefix . "linkmagic_links WHERE ShortCode='$Final' ";
    $row = $wpdb -> get_results($re);
    if ($row){
        foreach( $row as $rows ) {
            $L_ID=$rows->L_ID;
            $TargetURL=$rows->TargetURL;
            $RedirectType=$rows->RedirectType;
            $BackupURL=$rows->BackupURL;
            $RetargetingCode=$rows->RetargetingCode;
            $Title=$rows->Title;
            $Description=$rows->Description;
            $Keywords=$rows->Keywords;
            $OGImage=$rows->OGImage;
            
            //save the redirect data
            $IP=$_SERVER['REMOTE_ADDR'];
            $Refferer=$_SERVER["HTTP_REFERER"];
            $DateX=date('m/d/Y');
            $table_name = $wpdb->prefix . "linkmagic_hits";
            $sql="INSERT INTO $table_name (ForLink, DateX, UserIP, Refferer) VALUES('$L_ID', '$DateX', '$IP', '$Refferer') ";
            $wpdb->query($sql);
            
            include ("doredirect.php");
            
            exit();
            
        }
    }
    
}

register_activation_hook(__FILE__,'linkmagic_install');

function show_permission_denied_when_track_copy_to_root() {
    $class = 'notice notice-error';
    $message = __( 'There is some problem while copying track.php please copy it manually and paste it in root folder from Link Magic.', '' );
    
    printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), esc_html( $message ) );
}


function linkmagic_install() {
    global $wpdb;
    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    
    include('create_database.php');  
    // copy track.php files to root folder 
    if( !file_exists( ABSPATH . "/track.php" )){
        $trackFileContent = file_get_contents( ABSPATH . "/wp-content/plugins/link-magic/track.tpl" );
        $st = file_put_contents(ABSPATH . "/track.php", $trackFileContent );
        if( !$st ){
            add_action( 'admin_notices', 'show_permission_denied_when_track_copy_to_root' );
        }
    }
}

if ( is_admin() ){
    /* Call the html code */
    add_action('admin_menu', 'linkmagic_admin_menu');
    
    function linkmagic_admin_menu() {
        $iconUrl = plugin_dir_url( __FILE__ ) . 'images/favicon.png';
        add_menu_page('Link Magic', 'Link Magic', 'administrator','link-magic', 'linkmagic_admin', $iconUrl);
        add_submenu_page('link-magic', 'List', 'List', 0,'link-magic&s=v', 'link-magic&s=n');
        add_submenu_page('link-magic', 'Add New', 'Add New', 0,'link-magic&s=n', 'link-magic&s=n');
        #add_submenu_page('link-magic', 'License', 'License', 0,'link-magic&s=l', 'link-magic&s=l');
    }
}

function linkmagic_admin() {
    global $wpdb;
    // clone operation takes place earlier itself
    if( $_GET['s'] == 'cl'){
        include_once('clone.php');
        return;
    }
    wp_register_script('op_jq', '//ajax.googleapis.com/ajax/libs/jquery/1.6.0/jquery.min.js');
    wp_enqueue_script('op_jq');
    $PGPath=plugins_url()."/link-magic/";
    include('main.php');
    
}

add_shortcode('blm', 'linkmagic_internal_links' );

function linkmagic_internal_links($atts){
    global $wpdb;
    $BLM_ID=$atts['id'];
    $BLM_Word=$atts['word'];
    
    $re=" SELECT * FROM ".$wpdb->prefix . "linkmagic_links WHERE L_ID='$BLM_ID' ";
    $row = $wpdb -> get_results($re);
    if ($row){
        foreach( $row as $rows ) {
            $ShortCode=$rows->ShortCode;
        }
        
        add_filter('the_content',
            function ($content) use ($BLM_Word, $BLM_ID, $ShortCode){
                $SiteURL=site_url();
                $URL=$SiteURL."/".$ShortCode."/";
                $content=str_ireplace($BLM_Word,"<a rel='nofollow' href='$URL' target='_blank'>$BLM_Word</a>", $content);;
                return $content;
            },5);
        
        
        
    }
}

// short code for tracking visitor
function link_magic_track_visitor( $atts ){
    global $wpdb;
    
    if( isset($atts['track_visitor']) && $atts['track_visitor'] == "true"){
        // start tracking visitor
        $linkId = isset($atts['id'])?$atts['id']:0;
        // check if Conversion URL is added 
        $query =" SELECT ConversionURL FROM ".$wpdb->prefix . "linkmagic_links WHERE L_ID='$linkId' ";
        $row = $wpdb->get_row( $query);
        if( $row->ConversionURL != "" ){
            $table_name = $wpdb->prefix . "linkmagic_hits";
            
            $IP=$_SERVER['REMOTE_ADDR'];
            $Refferer=$_SERVER["HTTP_REFERER"];
            $DateX=date('m/d/Y');
            $table_name = $wpdb->prefix . "linkmagic_hits";
            $sql="INSERT INTO $table_name (ForLink, DateX, UserIP, Refferer, Sold) VALUES('$linkId', '$DateX', '$IP', '$Refferer', '1') ";
            $wpdb->query($sql);
        }
    }
    
}
add_shortcode("linkmagic", "link_magic_track_visitor");

/**
 * Add a widget to the dashboard.
 *
 * This function is hooked into the 'wp_dashboard_setup' action below.
 */
function link_magic_add_dashboard_widgets() {
    wp_add_dashboard_widget(
        'link_magic_dashboard_widget',         // Widget slug.
        'Link Magic - Add Link',         // Title.
        'link_magic_dashboard_widget_function' // Display function.
        );
}
add_action( 'wp_dashboard_setup', 'link_magic_add_dashboard_widgets', "1" );

/**
 * Create the function to output the contents of our Dashboard Widget.
 */

function link_magic_dashboard_widget_function() {
    $PGPath=plugins_url()."/link-magic/";
    include('new.php');
}
/*** home page video widget */
/**
 * Add a widget to the dashboard.
 *
 * This function is hooked into the 'wp_dashboard_setup' action below.
 */
function link_magic_add_dashboard_video_widgets() {
    wp_add_dashboard_widget(
        'mike_plugin_home_video_widget',         // Widget slug.
        'Important Next Steps - Start Here',         // Title.
        'link_magic_dashboard_video_widget_function' // Display function.
        );
    global $wp_meta_boxes;

    // Get the regular dashboard widgets array 
    // (which has our new widget already but at the end)    
    $normal_dashboard = $wp_meta_boxes['dashboard']['normal']['core'];

    // Backup and delete our new dashbaord widget from the end of the array    
    $video_widget = array( 'mike_plugin_home_video_widget' => 
        $normal_dashboard['mike_plugin_home_video_widget'] );
    unset( $normal_dashboard['mike_plugin_home_video_widget'] );

    // Merge the two arrays together so our widget is at the beginning   
    $sorted_dashboard = array_merge( $video_widget, $normal_dashboard );

    // Save the sorted array back into the original metaboxes     
    $wp_meta_boxes['dashboard']['normal']['core'] = $sorted_dashboard;

    // $my_widget = $wp_meta_boxes['dashboard']['normal']['core']['mike_plugin_home_video_widget'];
    // unset($wp_meta_boxes['dashboard']['normal']['core']['mike_plugin_home_video_widget']);
    // $wp_meta_boxes['dashboard']['side']['core']['mike_plugin_home_video_widget'] = $my_widget;

}
add_action( 'wp_dashboard_setup', 'link_magic_add_dashboard_video_widgets', 10 );

/**
 * Create the function to output the contents of our Dashboard Widget.
 */

function link_magic_dashboard_video_widget_function() {
    include_once('video.php');
}
/*  homepage video widget */

/** check for updates by tom**/
$path = plugin_basename(__FILE__);
function linkmagic_plugin_update_message( $data, $response ) {
    $plugin_version = $response['Version'];
    $update_url = "https://epicmarketer.com/updates/link_magic.json";
    $plugin_update_data = wp_remote_get($update_url);
    $plugin_update_message = "";
    $plugin_update_version = $plugin_version;
    if( is_array($plugin_update_data)){
        $plugin_update_body = $plugin_update_data['body'];
        $plugin_update_json = json_decode($plugin_update_body);
        $plugin_update_version = $plugin_update_json->Version;
        $plugin_update_message = $plugin_update_json->Message;
    }
    
    
    if( version_compare($plugin_update_version, $plugin_version, ">")){
        // latest version available
        $msg = '<div class="update-message notice inline notice-warning notice-alt"><p>There is an important security update for this plugin. <a href="https://epicmarketer.com/memberlogin">Click here</a> to download it. ' . $plugin_update_message . '</p></div>';
        printf(
            '<tr class="active"><td>&nbsp;</td><td colspan="2"><div><p><strong>%s</strong></p></div></td></tr>',
            __( $msg, 'text-domain' )
            );
    }
}
global $pagenow;
if(is_admin() && $pagenow == "plugins.php"){
    add_action( 'after_plugin_row_' . $path, 'linkmagic_plugin_update_message', 10, 2 );
}



// dashboard magic integration using separate function
	/**
	 * dashboard magic integration 
	 */
    if( !function_exists('dashboard_magic_announcement_from_epicmarketer')){
        function dashboard_magic_announcement_from_epicmarketer() {
            global $pagenow;
            $dashboardUrl = "https://epicmarketer.com/dashboard/";
            if( is_admin() && $pagenow == 'index.php') {
                $request = wp_remote_get($dashboardUrl);
                $response = wp_remote_retrieve_body( $request );
                echo "<div class='dashboard_magic_announcement_container' id='dashboard_magic_announcement_container'>";
                //echo "<iframe id='dashboard_magic_announcement_iframe' src='" . OH_DASHBOARD_MAGIC_ANNOUNCEMENT_URL . "' onload='resizeDiv()'></iframe>";
                echo "<div class='dashboard_magic_announcement_block' id='dashboard_magic_announcement_block'>$response</div>";
                
                echo "</div>";
            }
        }
        add_action('admin_notices', 'dashboard_magic_announcement_from_epicmarketer', 1);
    
    }
    if( !function_exists('enqueue_dashboard_magic_styles')){
        function enqueue_dashboard_magic_styles() {
            // Enqueue your plugin stylesheet
            wp_enqueue_style('dashboard-magic-style', plugins_url('dashboard.css', __FILE__), array(), '1.0', 'all');
        }
        add_action('admin_enqueue_scripts', 'enqueue_dashboard_magic_styles');
    }
    